// patan list filter

class ListFilter{
	constructor(patan, scope){
		this._patan = patan;
		this._scope = scope;
		this._list = null;
		this._silhouettes = null;
		this._tagList = null;
		this._tagFilter = null;
	}

	get silhouettes(){ return this._silhouettes; }

	reset(){
		this._tagFilter = null;
		this._buildTagList();
		this._buildList();
	}

	refresh(){
		this._buildTagList();
		var tagFilter = this._tagFilter;
		if( this._tagList.findIndex(function(tag, index, array){return tag == tagFilter;}) < 0 ){
			this._tagFilter = null;
		}
		this._buildList();
	}

	getRealSilhouetteIndex(listIndex){
		return this._list[listIndex];
	}

	getSilhouetteTagsHtml(classInfo){
		var html = '&nbsp;';
		for( var i = 0; i < this._tagList.length; i++ ){
			var tag = this._tagList[i];
			var text = ( (tag == null || tag == '') ?
				('(' + (
					(i == 0) ?
					this._patan.localize.getCurrentLanguageString('sid_alltags') :
					this._patan.localize.getCurrentLanguageString('sid_emptytag')
				) +
				')') : (tag) );
			var isCurrent = (tag == this._tagFilter);
			html +=
				'<span class="' + ((isCurrent) ? classInfo.pn : classInfo.cn) +
				'" onclick="' + ((isCurrent) ? '' : ( (classInfo.fn) + '(' + i + ')') ) +
				';">' + text + '</span>&nbsp;';
		}
		return html;
	}

	setTagFilterByIndex(tagListIndex){
		this._tagFilter = this._tagList[tagListIndex];
		this._buildList();
	}

	_buildTagList(){
		var tags = [null, '', ];
		this._patan.silhouettes.forEach(function(silhouette){
			silhouette.tags.forEach(function(tag){
				if( tags.findIndex(function(t, index, array){return t == tag;}) < 0 ){
					tags.push(tag);
				}
			});
		});
		this._tagList = tags;
	}

	_buildList(){
		this._list = [];
		this._silhouettes = [];
		for( var i = 0; i < this._patan.silhouettes.length; i++ ){
			var silhouette = this._patan.silhouettes[i];

			if( this._tagFilter != null ){
				if( this._tagFilter == '' ){
					if( silhouette.tags.length > 0){
						continue;
					}
				}else{
					var tagFilter = this._tagFilter;
					if( silhouette.tags.findIndex(function(tag, index, array){return tag == tagFilter;}) < 0 ){
						continue;
					}
				}
			}

			this._list.push(i);
			this._silhouettes.push(this._patan.silhouettes[i]);
		}
	}
}
