// application localizer

class Localize{
	constructor(){
		this._lang_list = [
			'jpn',
			'eng',
		];
		this._lang_title_list = [
			'日本語',
			'English',
		];
		this._sid_list = [
			'sid_notsupporthtml5',
			'sid_reset',
			'sid_ddorselectjte',
			'sid_pleasewait',
			'sid_or',
			'sid_source',
			'sid_available',
			'sid_jtereaderror',
			'tid_togglenightmode',
			'tid_forward',
			'tid_back',
			'tid_download',
			'tid_print',
			'tid_togglecoloring',
			'tid_togglecoloring2',
			'tid_scrolluptotop',
			'tid_topmoremenu',
			'tid_listmoremenu',
			'tid_editmoremenu',
			'tid_toplessmenu',
			'tid_listlessmenu',
			'tid_editlessmenu',
			'tid_togglenumperpage',
			'tid_sortbyfeatures',
			'tid_deletemode',
			'sid_deletemode',
			'tid_undo',
			'tid_redo',
			'tid_centering',
			'tid_break',
			'tid_rewined',
			'tid_togglezoom',
			'tid_hint',
			'sid_hint',
			'tid_imagedownload',
			'tid_imagedownload_wide',
			'tid_tweet',
			'sid_tags',
			'sid_alltags',
			'sid_emptytag',
			'tid_silhouetteadd',
			'tid_silhouetteset',
			'tid_silhouettetranscribe',
		];
		this._sid_type = {
			'sid_notsupporthtml5': 'innerText',
			'sid_reset': 'innerText',
			'sid_ddorselectjte': 'innerText',
			'sid_pleasewait': 'innerText',
			'sid_or': 'innerText',
			'sid_source': 'innerText',
			'sid_available': 'innerText',
			'sid_jtereaderror': '',
			'tid_togglenightmode': 'title',
			'tid_forward': 'title',
			'tid_back': 'title',
			'tid_download': 'title',
			'tid_print': 'title',
			'tid_togglecoloring': 'title',
			'tid_togglecoloring2': 'title',
			'tid_scrolluptotop': 'title',
			'tid_topmoremenu': 'title',
			'tid_listmoremenu': 'title',
			'tid_editmoremenu': 'title',
			'tid_toplessmenu': 'title',
			'tid_listlessmenu': 'title',
			'tid_editlessmenu': 'title',
			'tid_togglenumperpage': 'title',
			'tid_sortbyfeatures': 'title',
			'tid_deletemode': 'title',
			'sid_deletemode': '',
			'tid_undo': 'title',
			'tid_redo': 'title',
			'tid_centering': 'title',
			'tid_break': 'title',
			'tid_rewined': 'title',
			'tid_togglezoom': 'title',
			'tid_hint': 'title',
			'sid_hint': '',
			'tid_imagedownload': 'title',
			'tid_imagedownload_wide': 'title',
			'tid_tweet': 'title',
			'sid_tags': 'innerText',
			'sid_alltags': '',
			'sid_emptytag': '',
			'tid_silhouetteadd': 'title',
			'tid_silhouetteset': 'title',
			'tid_silhouettetranscribe': 'title',
		};
		this._string_resource = {
			'jpn': {
			'sid_notsupporthtml5': 'この環境はHTML5をサポートしていません。ブラウザを最新にしてください。',
			'sid_reset': '（困ったときのリセット）',
			'sid_ddorselectjte': 'ここにjteファイルをドラッグ＆ドロップするか、クリックしてファイルを選んでください。',
			'sid_pleasewait': 'しばしお待ちください。',
			'sid_or': 'または',
			'sid_source': 'プリセット',
			'sid_available': 'のを読みます。',
			'sid_jtereaderror': 'jteファイルの展開に失敗しました。',
			'tid_togglenightmode': '昼夜色テーマの切り替え',
			'tid_forward': '進む',
			'tid_back': '戻る',
			'tid_download': 'ダウンロード',
			'tid_print': '印刷用の表示',
			'tid_togglecoloring': '色の切り替え',
			'tid_togglecoloring2': '色の切り替え',
			'tid_scrolluptotop': 'ページ先頭までスクロール',
			'tid_topmoremenu': 'もっと表示',
			'tid_listmoremenu': 'もっと表示',
			'tid_editmoremenu': 'もっと表示',
			'tid_toplessmenu': '少なく表示',
			'tid_listlessmenu': '少なく表示',
			'tid_editlessmenu': '少なく表示',
			'tid_togglenumperpage': '1ページに表示するシルエットの数の切り替え',
			'tid_sortbyfeatures': '形で並べ替え',
			'tid_deletemode': 'クリックしたシルエットを削除するモードとの切り替え',
			'sid_deletemode': '×',
			'tid_undo': '元に戻す',
			'tid_redo': 'やり直す',
			'tid_centering': '中央に移動',
			'tid_break': '崩す',
			'tid_rewined': '巻き戻す',
			'tid_togglezoom': 'ズームの切り替え',
			'tid_hint': 'ヒントの表示',
			'sid_hint': 'ピースを選んでそこそこゆっくり左右に振ると反転します。',
			'tid_imagedownload': '画像をダウンロード',
			'tid_imagedownload_wide': '16:9、ピースセット付き画像をダウンロード',
			'tid_tweet': '画像をツイート',
			'sid_tags': 'タグ',
			'sid_alltags': '全て',
			'sid_emptytag': '空',
			'tid_silhouetteadd': 'シルエットを追加',
			'tid_silhouetteset': 'シルエットを交換',
			'tid_silhouettetranscribe': 'ピースセットのシルエットに設定',
			},
			'eng': {
			'sid_notsupporthtml5': 'This environment does not support HTML5 features. Please update your browser.',
			'sid_reset': '(reset for troubled situation)',
			'sid_ddorselectjte': 'Drag and drop or click to select jte file.',
			'sid_pleasewait': 'Please wait a moment.',
			'sid_or': 'Or select one from ',
			'sid_source': 'the following presets',
			'sid_available': '.',
			'sid_jtereaderror': 'failuer to expand jte file.',
			'tid_togglenightmode': 'toggle day or night color theme',
			'tid_forward': 'forward',
			'tid_back': 'back',
			'tid_download': 'download',
			'tid_print': 'print image',
			'tid_togglecoloring': 'toggle coloring',
			'tid_togglecoloring2': 'toggle coloring',
			'tid_scrolluptotop': 'scroll up to page top',
			'tid_listmoremenu': 'more menu',
			'tid_editmoremenu': 'more menu',
			'tid_listlessmenu': 'less menu',
			'tid_editlessmenu': 'less menu',
			'tid_togglenumperpage': 'toggle the number of silhouettes per a page',
			'tid_sortbyfeatures': 'sort by shape of silhouettes',
			'tid_deletemode': 'toggle deleting selected silhouette mode',
			'sid_deletemode': 'DELETE  ',
			'tid_undo': 'undo',
			'tid_redo': 'redo',
			'tid_centering': 'centering',
			'tid_break': 'break',
			'tid_rewined': 'rewined',
			'tid_togglezoom': 'toggle zooming',
			'tid_hint': 'show hint',
			'sid_hint': 'Select pieces and shake horizontal modarately to turn from side to side.',
			'tid_imagedownload': 'download as image',
			'tid_imagedownload_wide': 'download as image(16:9, with pieceset)',
			'tid_tweet': 'tweet image',
			'sid_tags': 'tags',
			'sid_alltags': 'all',
			'sid_emptytag': 'empty',
			'tid_silhouetteadd': 'add silhouette',
			'tid_silhouetteset': 'reflect silhouette',
			'tid_silhouettetranscribe': 'set silhouette as pieceset',
			},
		};
		this._cuurentLangid = 0;
	}

	resetLanguage(){
		var language = (window.navigator.languages && window.navigator.languages[0]) ||
			window.navigator.language ||
			window.navigator.userLanguage ||
			window.navigator.browserLanguage;
		this.setLanguage(language == 'ja' ? 0 : 1);
	}

	setLanguage(langid){
		this._currentLangid = langid;
		for( var i=0; i < this._sid_list.length; i++){
			var sid = this._sid_list[i];
			var str = this.getCurrentLanguageString(sid);
			if( this._sid_type[sid] == 'innerText'){
				$('#'+sid).text(str);
			 }else if( this._sid_type[sid] == 'title'){
				$('#'+sid).attr('title', str);
			 }
		}
	}

	getCurrentLanguageString(sid){
		return this._string_resource[ this._lang_list[ this._currentLangid ] ][sid];
	}

	buildLanguageSelector(classInfo){
		var html = '';
		for( var i = 0; i < this._lang_list.length; i++ ){
			html += '<img class="' + classInfo.cn + '" src="res/image/lang/' +
				this._lang_list[i] + '.png" title="' +
				this._lang_title_list[i]+'" onclick="' + classInfo.fn + '(' + i + ');">';
		}
		$('#languageselector').html(html);
	}
}
