// patan piece-set canvas

class PiecesetCanvas{
	constructor(patan, element){
		this._patan = patan;
		this._scope = new paper.PaperScope();
		this._scope.setup(element);

		this._group = new this._scope.Group();
	}

	reset(){
		this._setGroup();
	};

	refreshPiecesColor(){
		this._setPiecesColor();
		this._scope.view.draw();
	}


	_setPiecesColor(){
		this._group.strokeColor = this._patan.colorTheme.getCurrentThemeColor('cid_pststroke');
	}

	_setGroup(){
		var scope = this._scope;
		var group = this._group;

		scope.view.pause();
		scope.view.viewSize = new scope.Size(300,250);

		var pathData = this._patan.pieceset.svgPath;
		var pieceInfo = this._patan.pieceset.silhouette.p;
		var zoomRatio = this._patan.pieceset.zoomRatio;
		var zoom = 0.6;
		
		group.removeChildren();
		for( var n = 0; n < pieceInfo.length; n++ ){
			var cpath = new scope.CompoundPath(pathData[pieceInfo[n].kind]);
			cpath.pivot = ([0,0]);
			cpath.matrix.a = pieceInfo[n].flip;
			cpath.rotate(pieceInfo[n].angle);
			cpath.translate(pieceInfo[n].position);
			
			var newcpath = getHandWritingEffect(cpath,1.5);
			cpath.remove();
			newcpath.pivot = ([0,0]);
			
			group.addChild(newcpath);
		}
		group.scaling = zoom * zoomRatio;
		group.position = scope.view.center;
		group.strokeCap = 'round';
		group.strokeJoin = 'bevel';
		group.strokeWidth = 1.5;
		this._setPiecesColor();

		scope.view.draw();
	}
}
