// communication with tangrams' web storage
function getTwsEntries(){
	var html = getTwsTopPage();
}

function getTwsTopPage(){
	$.ajax({
		url:'./preset/list.json',
		type:'get',
		dataType: 'json'
	}).then(
		function(data){
			//success, try to create tws entries
			if( data != null && data.jteList != null && data.jteList.length > 0 ){
				data.jteList.forEach(function(item){ buildTwsEntriesHtml(item.url); });
			}
		},
		function(){
			//failure
			window.alert('network error (x_x,.)');
		}
	);
}

function buildTwsEntriesHtml(url){
	$.ajax({
		url:url,
		type:'get',
		dataType: 'text',
		context:url
	}).then(
		function(data){
			//success, create tws entries
			if( data != null && data.length > 0 ){
				let html = '';
				let silhouettePuzzle = {};
				const ret = patan.jte.expandJteXml(data, silhouettePuzzle, false);
				if( ret.result ){
					if( patan.twsPieceSetList.length == 0){
						$('#twsentriesarea').css('display', '');
					}
					else{
						html = $('#twsentries').html();
					}
					const index = patan.twsPieceSetList.length;
					silhouettePuzzle.pieceset.url = this;
					silhouettePuzzle.pieceset.index = index;
					pieceSet = silhouettePuzzle.pieceset;
					patan.twsPieceSetList.push(pieceSet);
					html += getTwsEntryHtml(pieceSet);
					$('#twsentries').html(html);
				}
			}
		},
		function(){
			//failure
			window.alert('network error (-.-u)');
		}
	);
}

function getTwsEntryHtml(pieceSet){
	let html = '';
	let dataURL = workCanvas.getDataURL(
		pieceSet.svgPath,
		pieceSet.zoomRatio,
		pieceSet.silhouette.p,
		patan.colorTheme.getCurrentThemeColor('cid_twsfill'),
		patan.colorTheme.getCurrentThemeColor('cid_twsstroke'),
		0.4);
	let sz = 80;
	let padh = Math.round((sz - dataURL.width/2)/2);
	let padv = Math.round((sz - dataURL.height/2)/2);
	html += '<a class="clickable" title="' + pieceSet.name + '" onclick="loadXmlFromTws(' + pieceSet.index + ');">';
	html += '<img src="' + dataURL.url + '" style="padding:' + padv + 'px ' + padh + 'px" ' + 
		'width="' + Math.round(dataURL.width/2) + 'px" height="' + Math.round(dataURL.height/2) + 'px">';
	html += '</a>';
	return html;
}

function resetTwsEntriesHtml(){
	let html = '';
	patan.twsPieceSetList.forEach(function(pieceSet){ html += getTwsEntryHtml(pieceSet); });
	$('#twsentries').html(html);
}

function loadXmlFromTws(index){
	const url = patan.twsPieceSetList[index].url;
	$.ajax({
		url:url,
		type:'get',
		dataType: 'text',
		context:url
	}).then(
		function(data){
			//success, create silhouette list
			let silhouettePuzzle = {};
			const ret = patan.jte.expandJteXml(data, silhouettePuzzle);
			if( ret.result ){
				patan.directSetSilhouettePuzzle(silhouettePuzzle, this);
				onSetSilhouettePuzzle();
				transPageFromLoadToMain();
			}
		},
		function(){
			//failure
			window.alert('network error (><#)');
			$('#please_wait_layer').css('display','none');
			$('#load_or_select_layer').css('display','');
		}
	);
	$('#load_or_select_layer').css('display','none');
	$('#please_wait_layer').css('display','');
}
