// library for paperjs

// getHandWritingEffect
function getHandWritingEffect(cpath, ratio){
	var newcpath = new paper.CompoundPath();
	
	for( var i = 0; i < cpath.children.length; i++ ){
		var path = cpath.children[i];
		var newpath = new paper.Path();
		var sign = 0.5 * ratio;
		for( var l = 0; l < path.length; l += (1.0 + Math.random() * 4.0) * ratio ){
			var point = path.getPointAt(l);
			var normal = path.getNormalAt(l).normalize();
			var level = Math.random()*sign;
			var newpoint = new paper.Point(point.x + level * normal.x, point.y + level * normal.y);
			sign = -sign;
			newpath.addSegment(newpoint);
		}
		if( path.closed ){
			newpath.closePath(true);
		}else{
			newpath.addSegment(path.getPointAt(path.length));
		}
		newcpath.addChild(newpath);
	}
	
	return newcpath;
}
